class Town {
	id = 0;
	last_growth = 0;
	last_message = "";
	paxRequired = GSController.GetSetting("min_transport_pax");
	mailRequired = GSController.GetSetting("min_transport_mail");

	constructor (t_id) {
		this.id = t_id;
	}

	function ManageTown() {
		// if the size of the town is below the threshold, set the growth rate to normal
		local threashold_setting = GSController.GetSetting("town_size_threshold");
		local townPopulation = GSTown.GetPopulation(this.id);
		if (townPopulation <= threashold_setting) {
			this.SetGrowthRate(GSTown.TOWN_GROWTH_NORMAL);
			this.SetText(GSText(GSText.STR_TOO_SMALL));
			return;
		}

		if (paxRequired && mailRequired) {
			local success1 = true;
			local success2 = true;
			local text1 = null;
			local text2 = null;
			local text3 = null;
			local text4 = null;

			local paxTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetPAXCargo());
			local mailTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetMailCargo());
			if (paxTransport < 0) paxTransport = 0;
			if (mailTransport < 0) mailTransport = 0;
			local PaxTooLow = paxTransport < this.paxRequired;
			local MailTooLow = mailTransport < this.mailRequired;

			if (PaxTooLow || MailTooLow) {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NONE);
			} else {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NORMAL);
			}
			text1 = PaxTooLow ?
				GSText(GSText.STR_PAX_BAD, paxTransport) :
				GSText(GSText.STR_PAX_GOOD, paxTransport);
			text2 = MailTooLow ?
				GSText(GSText.STR_MAIL_BAD, mailTransport) :
				GSText(GSText.STR_MAIL_GOOD, mailTransport);
			text3 = GSText(GSText.STR_PAX_GOAL, this.paxRequired);
			text4 = GSText(GSText.STR_MAIL_GOAL, this.mailRequired);
			success2 = this.SetText(GSText(GSText.STR_2, text1, text3, text2, text4));

			return success1 && success2;
		}

		else if (paxRequired) {
			local success1 = true;
			local success2 = true;
			local text1 = null;
			local text2 = null;
			local paxTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetPAXCargo());
			if (paxTransport < 0) paxTransport = 0;
			local PaxTooLow = paxTransport < this.paxRequired;
			if (PaxTooLow) {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NONE);
				text1 = GSText(GSText.STR_PAX_BAD, paxTransport);
			} else {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NORMAL);
				text1 = GSText(GSText.STR_PAX_GOOD, paxTransport);
			}
			text2 = GSText(GSText.STR_PAX_GOAL, this.paxRequired);
			success2 = this.SetText(GSText(GSText.STR_1, text1, text2));

			return success1 && success2;
		}

		else if (mailRequired) {
			local success1 = true;
			local success2 = true;
			local text1 = null;
			local text2 = null;
			local mailTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetMailCargo());
			if (mailTransport < 0) mailTransport = 0;
			local MailTooLow = mailTransport < this.mailRequired;
			if (MailTooLow) {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NONE);
				text1 = GSText(GSText.STR_MAIL_BAD, mailTransport);
			} else {
				success1 = this.SetGrowthRate(GSTown.TOWN_GROWTH_NORMAL);
				text1 = GSText(GSText.STR_MAIL_GOOD, mailTransport);
			}
			text2 = GSText(GSText.STR_MAIL_GOAL, this.mailRequired);
			success2 = this.SetText(GSText(GSText.STR_1, text1, text2));

			return success1 && success2;
		}
	}

	function SetGrowthRate(value) {
		local success = true;
		if (this.last_growth != value) {
			this.last_growth = value;
			success = GSTown.SetGrowthRate(this.id, value);
		}
		return success;
	}

	function SetText(value) {
		local success = true;
		if (this.last_message != value) {
			this.last_message = value;
			success = GSTown.SetText(this.id, this.last_message);
		}
		return success;
	}
}
